# -*- encoding=utf8 -*-
__author__ = "liguangyu"

"""
case_tag:cmdc_api,cmdc返利发放新增验证,2271,2271-40,sit,bs
主数据平台:后台运营系统返利发放新增接口
"""

from common.common_func import commonFuc
from air_case.cmdc_login.后台管理系统登录.后台管理系统登录 import CmdcDoLogin
from common.db.db import mySql
import requests
import random
import uuid
import json

module = "cmdc_rebate"

# 第一步登录后台运营平台获取cmdc_access_token
# 获取登录所需账号密码
username = commonFuc().get_business_data(module, "username1")
password = commonFuc().get_business_data(module, "password1")
# 获取登录后Cmdc_access_token
cmdc_access_token = CmdcDoLogin(username, password).get_token()
headers = commonFuc().get_business_data(module, "json_headers", cmdc_access_token)

# 生成返利发放规则主题
theme = uuid.uuid4()
# 生成可抵扣下单金额最高比例
use_limit = random.randint(1, 99)
# 第二步进行返利发放规则新增
url = commonFuc().get_api_url() + commonFuc().get_business_data(module, "url43")
request_body = commonFuc().get_business_data(module, "payload43", theme, use_limit)

"""
 场景: 返利发放新增验证
 用例名称：返利发放新增验证
 输出：{"rebateTheme":"%s"}
"""

# 发送请求
result = requests.post(url, json=request_body, headers=headers)
result = json.loads(result.content)
# print(result)
if result["success"]:
    # 获取返利发放明细
    rebate_trip_id = result["data"]["rebateTripId"]
    rebate_theme = result["data"]["rebateTheme"]
    print(rebate_trip_id)
    # 数据库操作
    mysql_handle = mySql()
    # 获取conf.ini文件中配置的数据库信息
    host, port, user, pwd = mysql_handle.getConf(db="cmdc_db")

    # 数据库查询返利发放规则主题
    sql = "SELECT t.rebateTheme FROM `cmdc-order`.tc_rebatetrip t WHERE rebateTripId = {}".format(rebate_trip_id)
    result = {"rebateTheme": mysql_handle.selectSql(host, port, user, pwd, "cmdc-order", sql)[0][0]}
    # print(result)
    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict43", rebate_theme)
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)
    # 对新增的返利发放规则进行删除操作
    sql = "DELETE FROM `cmdc-order`.tc_rebatetrip WHERE rebateTripId = {}".format(rebate_trip_id)
    mysql_handle.executeUpdate(host, port, user, pwd, "cmdc-order", sql)
else:
    # 获取预期结果
    check_dict = commonFuc().get_business_data(module, "checkDict43_1")
    # 断言实际结果中是否包含预期结果的内容
    commonFuc().check_result(check_dict, result)